Index: src/Actions/WorldAction/SetDefaultNameAction.cpp
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/WorldAction/SetDefaultNameAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,74 @@
+/*
+ * SetDefaultNameAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/WorldAction/SetDefaultNameAction.hpp"
+#include "CommandLineParser.hpp"
+#include "log.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char WorldSetDefaultNameAction::NAME[] = "default-molname";
+
+WorldSetDefaultNameAction::WorldSetDefaultNameAction() :
+  Action(NAME)
+{}
+
+WorldSetDefaultNameAction::~WorldSetDefaultNameAction()
+{}
+
+Action::state_ptr WorldSetDefaultNameAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  string defaultname;
+
+  defaultname = World::getInstance().getDefaultName();
+  dialog->queryString(NAME, &defaultname, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    char outputname[MAXSTRINGSIZE];
+    strcpy(outputname, defaultname.c_str());
+    World::getInstance().setDefaultName(outputname);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr WorldSetDefaultNameAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr WorldSetDefaultNameAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool WorldSetDefaultNameAction::canUndo() {
+  return false;
+}
+
+bool WorldSetDefaultNameAction::shouldUndo() {
+  return false;
+}
+
+const string WorldSetDefaultNameAction::getName() {
+  return NAME;
+}
Index: src/Actions/WorldAction/SetDefaultNameAction.hpp
===================================================================
--- src/Actions/WorldAction/SetDefaultNameAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/WorldAction/SetDefaultNameAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * SetDefaultNameAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef SETDEFAULTNAMEACTION_HPP_
+#define SETDEFAULTNAMEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class WorldSetDefaultNameAction : public Action {
+public:
+  WorldSetDefaultNameAction();
+  virtual ~WorldSetDefaultNameAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* SETDEFAULTNAMEACTION_HPP_ */
Index: src/Actions/WorldAction/SetGaussianBasisAction.cpp
===================================================================
--- src/Actions/WorldAction/SetGaussianBasisAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/WorldAction/SetGaussianBasisAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,69 @@
+/*
+ * SetGaussianBasisAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/WorldAction/SetGaussianBasisAction.hpp"
+#include "CommandLineParser.hpp"
+#include "config.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char WorldSetGaussianBasisAction::NAME[] = "set-basis";
+
+WorldSetGaussianBasisAction::WorldSetGaussianBasisAction() :
+  Action(NAME)
+{}
+
+WorldSetGaussianBasisAction::~WorldSetGaussianBasisAction()
+{}
+
+Action::state_ptr WorldSetGaussianBasisAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryString(NAME, &World::getInstance().getConfig()->basis, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr WorldSetGaussianBasisAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr WorldSetGaussianBasisAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool WorldSetGaussianBasisAction::canUndo() {
+  return false;
+}
+
+bool WorldSetGaussianBasisAction::shouldUndo() {
+  return false;
+}
+
+const string WorldSetGaussianBasisAction::getName() {
+  return NAME;
+}
Index: src/Actions/WorldAction/SetGaussianBasisAction.hpp
===================================================================
--- src/Actions/WorldAction/SetGaussianBasisAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/WorldAction/SetGaussianBasisAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * SetGaussianBasisAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef SETGAUSSIANBASISACTION_HPP_
+#define SETGAUSSIANBASISACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class WorldSetGaussianBasisAction : public Action {
+public:
+  WorldSetGaussianBasisAction();
+  virtual ~WorldSetGaussianBasisAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* SETGAUSSIANBASISACTION_HPP_ */
Index: src/CommandLineParser.cpp
===================================================================
--- src/CommandLineParser.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/CommandLineParser.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,80 @@
+/*
+ * CommandLineParser.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include <boost/program_options.hpp>
+#include <fstream>
+#include <iostream>
+
+#include "Patterns/Singleton_impl.hpp"
+#include "CommandLineParser.hpp"
+
+using namespace std;
+
+/** Constructor of class CommandLineParser.
+ *
+ */
+CommandLineParser::CommandLineParser() :
+  generic("Generic options"),
+  config("Configuration"),
+  hidden("Hidden options"),
+  visible("Allowed options")
+{}
+
+/** Destructor of class CommandLineParser.
+ *
+ */
+CommandLineParser::~CommandLineParser()
+{}
+
+/** Parses the command line arguments.
+ * Calls program_options::store() and program_options::notify()
+ */
+void CommandLineParser::Parse()
+{
+  po::store(po::command_line_parser(argc,argv).options(cmdline_options).options(visible).positional(inputfile).run(), vm);
+  ifstream input;
+  input.open("example.cfg");
+  if (!input.fail())
+    po::store(po::parse_config_file(input, config_file_options), vm);
+  input.close();
+  po::notify(vm);
+}
+
+
+
+/** States whether there are command line arguments.
+ * \return true - there are none, false - there is at least one command line argument
+ */
+bool CommandLineParser::isEmpty()
+{
+  return vm.empty();
+}
+
+/** Sets the options.
+ * \param _argc arg count from main()
+ * \param **_argv argument array from main()
+ */
+void CommandLineParser::setOptions(int _argc, char **_argv)
+{
+  argc = _argc;
+  argv = _argv;
+  cmdline_options.add(generic).add(config).add(hidden);
+  config_file_options.add(config).add(hidden);
+  visible.add(generic).add(config);
+}
+
+/** Makes the Parser parse the command line options with current known options.
+ * \param _argc arg count from main()
+ * \param **_argv argument array from main()
+ */
+void CommandLineParser::Run(int _argc, char **_argv)
+{
+  setOptions(_argc,_argv);
+  Parse();
+}
+
+CONSTRUCT_SINGLETON(CommandLineParser)
Index: src/CommandLineParser.hpp
===================================================================
--- src/CommandLineParser.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/CommandLineParser.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,64 @@
+/*
+ * CommandLineParser.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEPARSER_HPP_
+#define COMMANDLINEPARSER_HPP_
+
+#include <boost/program_options.hpp>
+
+namespace po = boost::program_options;
+
+#include "Patterns/Singleton.hpp"
+
+
+class CommandLineParser : public Singleton<CommandLineParser> {
+  friend class Singleton<CommandLineParser>;
+public:
+
+  // Parses the command line arguments in CommandLineParser::**argv with currently known options.
+  void Run(int _argc, char **_argv);
+
+  // Checks whether there have been any commands on the command line.
+  bool isEmpty();
+
+  /* boost's program_options are sorted into three categories:
+   * -# generic options: option available to both command line and config
+   * -# config options: only available in the config file
+   * -# hidden options: options which the user is not shown on "help"
+   */
+  po::options_description generic;
+  po::options_description config;
+  po::options_description hidden;
+  po::positional_options_description inputfile;
+
+  po::options_description visible;
+
+  po::variables_map vm;
+
+private:
+  // private constructor and destructor
+  CommandLineParser();
+  virtual ~CommandLineParser();
+
+  /* The following program_options options_decriptions are used to
+   * generate the various cases and call differently in Parse().
+   */
+  po::options_description cmdline_options;
+  po::options_description config_file_options;
+
+  // Sets the options from the three cases.
+  void setOptions(int _argc, char **_argv);
+
+  // Parses all options from command line and config file
+  void Parse();
+
+  // argument counter and array passed on from main()
+  int argc;
+  char **argv;
+};
+
+#endif /* COMMANDLINEPARSER_HPP_ */
Index: src/Legacy/oldmenu.cpp
===================================================================
--- src/Legacy/oldmenu.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/Legacy/oldmenu.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -35,4 +35,5 @@
 #include "Menu/DisplayMenuItem.hpp"
 #include "Menu/SubMenuItem.hpp"
+#include "Actions/MapOfActions.hpp"
 #include "Actions/MethodAction.hpp"
 #include "Actions/ErrorAction.hpp"
@@ -908,6 +909,6 @@
   molecule *srcmol = NULL, *destmol = NULL;
   Dialog *dialog = UIFactory::getInstance().makeDialog();
-  dialog->queryMolecule("Enter index of destination molecule: ",&destmol, molecules);
-  dialog->queryMolecule("Enter index of source molecule to add from: ",&srcmol, molecules);
+  dialog->queryMolecule("molecule-by-id",&destmol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  dialog->queryMolecule("molecule-by-id",&srcmol, MapOfActions::getInstance().getDescription("molecule-by-id"));
   if(dialog->display()) {
     molecules->SimpleAdd(srcmol, destmol);
@@ -922,6 +923,6 @@
   molecule *srcmol = NULL, *destmol = NULL;
   Dialog *dialog = UIFactory::getInstance().makeDialog();
-  dialog->queryMolecule("Enter index of matrix molecule (the variable one): ",&srcmol,molecules);
-  dialog->queryMolecule("Enter index of molecule to merge into (the fixed one): ",&destmol,molecules);
+  dialog->queryMolecule("molecule-by-id",&destmol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  dialog->queryMolecule("molecule-by-id",&srcmol, MapOfActions::getInstance().getDescription("molecule-by-id"));
   if(dialog->display()) {
     molecules->EmbedMerge(destmol, srcmol);
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/Makefile.am	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -1,66 +1,292 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
 # this includes source files that need to be present at multiple points
-HELPERSOURCE =  Helpers/Assert.cpp \
-		 		Helpers/MemDebug.cpp
+HELPERSOURCE =  \
+  Helpers/Assert.cpp \
+  Helpers/MemDebug.cpp
 		        
-ATOMSOURCE = atom.cpp atom_atominfo.cpp atom_bondedparticle.cpp atom_bondedparticleinfo.cpp atom_graphnode.cpp atom_graphnodeinfo.cpp atom_particleinfo.cpp atom_trajectoryparticle.cpp atom_trajectoryparticleinfo.cpp
-ATOMHEADER = atom.hpp atom_atominfo.hpp atom_bondedparticle.hpp atom_bondedparticleinfo.hpp atom_graphnode.hpp atom_graphnodeinfo.hpp atom_particleinfo.hpp atom_trajectoryparticle.hpp atom_trajectoryparticleinfo.hpp
-
-LINALGSOURCE = ${HELPERSOURCE} \
-               gslmatrix.cpp \
-			   gslvector.cpp \
-			   linearsystemofequations.cpp \
-			   Space.cpp \
-			   vector.cpp
+ATOMSOURCE = \
+  atom.cpp \
+  atom_atominfo.cpp \
+  atom_bondedparticle.cpp \
+  atom_bondedparticleinfo.cpp \
+  atom_graphnode.cpp \
+  atom_graphnodeinfo.cpp \
+  atom_particleinfo.cpp \
+  atom_trajectoryparticle.cpp \
+  atom_trajectoryparticleinfo.cpp
+ATOMHEADER = \
+  atom.hpp \
+  atom_atominfo.hpp \
+  atom_bondedparticle.hpp \
+  atom_bondedparticleinfo.hpp \
+  atom_graphnode.hpp \
+  atom_graphnodeinfo.hpp \
+  atom_particleinfo.hpp \
+  atom_trajectoryparticle.hpp \
+  atom_trajectoryparticleinfo.hpp
+
+LINALGSOURCE = \
+  ${HELPERSOURCE} \
+  gslmatrix.cpp \
+  gslvector.cpp \
+  linearsystemofequations.cpp \
+  Space.cpp \
+  vector.cpp
 			   
 LINALGHEADER = gslmatrix.hpp \
-			   gslvector.hpp \
-			   linearsystemofequations.hpp \
-			   Space.hpp \
-			   vector.hpp
+  gslvector.hpp \
+  linearsystemofequations.hpp \
+  Space.hpp \
+  vector.hpp
 			   
-
-ANALYSISSOURCE = analysis_bonds.cpp analysis_correlation.cpp
-ANALYSISHEADER = analysis_bonds.hpp analysis_correlation.hpp
+ANALYSISSOURCE = \
+  analysis_bonds.cpp \
+  analysis_correlation.cpp
+ANALYSISHEADER = \
+  analysis_bonds.hpp \
+  analysis_correlation.hpp
 
 ACTIONSSOURCE = Actions/Action.cpp \
-				Actions/ActionHistory.cpp \
-				Actions/ActionRegistry.cpp \
-				Actions/ActionSequence.cpp \
-				Actions/ErrorAction.cpp \
-				Actions/MakroAction.cpp \
-				Actions/ManipulateAtomsProcess.cpp \
-				Actions/MethodAction.cpp \
-                Actions/Process.cpp \
-                Actions/small_actions.cpp
-                
+  ${ANALYSISACTIONSOURCE} \
+  ${ATOMACTIONSOURCE} \
+  ${CMDACTIONSOURCE} \
+  ${FRAGMENTATIONACTIONSOURCE} \
+  ${MOLECULEACTIONSOURCE} \
+  ${PARSERACTIONSOURCE} \
+  ${TESSELATIONACTIONSOURCE} \
+  ${WORLDACTIONSOURCE} \
+  Actions/ActionHistory.cpp \
+  Actions/ActionRegistry.cpp \
+  Actions/ActionSequence.cpp \
+  Actions/ErrorAction.cpp \
+  Actions/MakroAction.cpp \
+  Actions/ManipulateAtomsProcess.cpp \
+  Actions/MapOfActions.cpp \
+  Actions/MethodAction.cpp \
+  Actions/Process.cpp
+
+ACTIONSHEADER = Actions/Action.hpp \
+  ${ANALYSISACTIONHEADER} \
+  ${ATOMACTIONHEADER} \
+  ${CMDACTIONHEADER} \
+  ${FRAGMENTATIONACTIONHEADER} \
+  ${MOLECULEACTIONHEADER} \
+  ${PARSERACTIONHEADER} \
+  ${TESSELATIONACTIONHEADER} \
+  ${WORLDACTIONHEADER} \
+  Actions/ActionHistory.hpp \
+  Actions/ActionRegistry.hpp \
+  Actions/ActionSequence.hpp \
+  Actions/Calculation.hpp \
+  Actions/Calculation_impl.hpp \
+  Actions/ErrorAction.hpp \
+  Actions/MakroAction.hpp \
+  Actions/ManipulateAtomsProcess.hpp \
+  Actions/MapOfActions.hpp \
+  Actions/MethodAction.hpp \
+  Actions/Process.hpp
+  
+ANALYSISACTIONSOURCE = \
+  Actions/AnalysisAction/MolecularVolumeAction.cpp \
+  Actions/AnalysisAction/PairCorrelationAction.cpp \
+  Actions/AnalysisAction/PairCorrelationToPointAction.cpp \
+  Actions/AnalysisAction/PairCorrelationToSurfaceAction.cpp \
+  Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
+ANALYSISACTIONHEADER = \
+  Actions/AnalysisAction/MolecularVolumeAction.hpp \
+  Actions/AnalysisAction/PairCorrelationAction.hpp \
+  Actions/AnalysisAction/PairCorrelationToPointAction.hpp \
+  Actions/AnalysisAction/PairCorrelationToSurfaceAction.hpp \
+  Actions/AnalysisAction/PrincipalAxisSystemAction.hpp
+
+ATOMACTIONSOURCE = \
+  Actions/AtomAction/AddAction.cpp \
+  Actions/AtomAction/ChangeElementAction.cpp \
+  Actions/AtomAction/RemoveAction.cpp
+ATOMACTIONHEADER = \
+  Actions/AtomAction/AddAction.hpp \
+  Actions/AtomAction/ChangeElementAction.hpp \
+  Actions/AtomAction/RemoveAction.cpp
+
+CMDACTIONSOURCE = \
+  Actions/CmdAction/BondLengthTableAction.cpp \
+  Actions/CmdAction/ElementDbAction.cpp \
+  Actions/CmdAction/FastParsingAction.cpp \
+  Actions/CmdAction/HelpAction.cpp \
+  Actions/CmdAction/VerboseAction.cpp \
+  Actions/CmdAction/VersionAction.cpp
+CMDACTIONHEADER = \
+  Actions/CmdAction/BondLengthTableAction.hpp \
+  Actions/CmdAction/ElementDbAction.hpp \
+  Actions/CmdAction/FastParsingAction.hpp \
+  Actions/CmdAction/HelpAction.hpp \
+  Actions/CmdAction/VerboseAction.hpp \
+  Actions/CmdAction/VersionAction.hpp
+
+FRAGMENTATIONACTIONSOURCE = \
+  Actions/FragmentationAction/DepthFirstSearchAction.cpp \
+  Actions/FragmentationAction/FragmentationAction.cpp \
+  Actions/FragmentationAction/SubgraphDissectionAction.cpp               
+FRAGMENTATIONACTIONHEADER = \
+  Actions/FragmentationAction/DepthFirstSearchAction.hpp \
+  Actions/FragmentationAction/FragmentationAction.hpp \
+  Actions/FragmentationAction/SubgraphDissectionAction.hpp
+
+MOLECULEACTIONSOURCE = \
+  Actions/MoleculeAction/BondFileAction.cpp \
+  Actions/MoleculeAction/ChangeNameAction.cpp \
+  Actions/MoleculeAction/FillWithMoleculeAction.cpp \
+  Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp \
+  Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp \
+  Actions/MoleculeAction/SaveAdjacencyAction.cpp \
+  Actions/MoleculeAction/SaveBondsAction.cpp \
+  Actions/MoleculeAction/SaveTemperatureAction.cpp \
+  Actions/MoleculeAction/SuspendInWaterAction.cpp \
+  Actions/MoleculeAction/TranslateAction.cpp \
+  Actions/MoleculeAction/VerletIntegrationAction.cpp
+MOLECULEACTIONHEADER = \
+  Actions/MoleculeAction/BondFileAction.hpp \
+  Actions/MoleculeAction/ChangeNameAction.hpp \
+  Actions/MoleculeAction/FillWithMoleculeAction.hpp \
+  Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp \
+  Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp \
+  Actions/MoleculeAction/SaveAdjacencyAction.hpp \
+  Actions/MoleculeAction/SaveBondsAction.hpp \
+  Actions/MoleculeAction/SaveTemperatureAction.hpp \
+  Actions/MoleculeAction/SuspendInWaterAction.hpp \
+  Actions/MoleculeAction/TranslateAction.hpp \
+  Actions/MoleculeAction/VerletIntegrationAction.hpp
                  
-ACTIONSHEADER = Actions/Action.hpp \
-				Actions/ActionHistory.hpp \
-				Actions/ActionRegistry.hpp \
-				Actions/ActionSequence.hpp \
- 			    Actions/Calculation.hpp \
- 			    Actions/Calculation_impl.hpp \
- 			    Actions/ErrorAction.hpp \
- 			    Actions/MakroAction.hpp \
- 			    Actions/ManipulateAtomsProcess.hpp \
- 			    Actions/MethodAction.hpp \
- 			    Actions/Process.hpp \
- 			    Actions/small_actions.hpp
- 			    
- 			    
-
-PATTERNSOURCE = Patterns/Observer.cpp
-PATTERNHEADER = Patterns/Cacheable.hpp \
-				Patterns/Observer.hpp \
-                Patterns/Singleton.hpp
-
-VIEWSOURCE = Views/View.cpp Views/StringView.cpp Views/MethodStringView.cpp Views/StreamStringView.cpp
-VIEWHEADER = Views/View.hpp Views/StringView.hpp Views/MethodStringView.hpp Views/StreamStringView.hpp
-
-MENUSOURCE = Menu/Menu.cpp Menu/TextMenu.cpp Menu/MenuItem.cpp Menu/SubMenuItem.cpp Menu/ActionMenuItem.cpp Menu/SeperatorItem.cpp Menu/DisplayMenuItem.cpp
-MENUHEADER = Menu/Menu.hpp Menu/TextMenu.hpp Menu/MenuItem.hpp Menu/SubMenuItem.hpp Menu/ActionMenuItem.hpp Menu/SeperatorItem.hpp Menu/DisplayMenuItem.hpp
-
-UISOURCE = ${ACTIONSSOURCE} ${VIEWSOURCE} ${MENUSOURCE} UIElements/UIFactory.cpp UIElements/TextUIFactory.cpp UIElements/MainWindow.cpp UIElements/TextWindow.cpp UIElements/TextStatusIndicator.cpp UIElements/Dialog.cpp UIElements/TextDialog.cpp
-UIHEADER = ${ACTIONSHEADER} ${VIEWHEADER} ${MENUHEADER} UIElements/UIFactory.hpp UIElements/TextUIFactory.hpp UIElements/MainWindow.hpp UIElements/TextWindow.hpp UIElements/TextStatusIndicator.hpp UIElements/Dialog.hpp UIElements/TextDialog.hpp
+PARSERACTIONSOURCE = \
+  Actions/ParserAction/LoadXyzAction.cpp \
+  Actions/ParserAction/SaveXyzAction.cpp       
+PARSERACTIONHEADER = \
+  Actions/ParserAction/LoadXyzAction.hpp \
+  Actions/ParserAction/SaveXyzAction.hpp
+
+TESSELATIONACTIONSOURCE = \
+  Actions/TesselationAction/ConvexEnvelopeAction.cpp \
+  Actions/TesselationAction/NonConvexEnvelopeAction.cpp               
+TESSELATIONACTIONHEADER = \
+  Actions/TesselationAction/ConvexEnvelopeAction.hpp \
+  Actions/TesselationAction/NonConvexEnvelopeAction.hpp
+
+WORLDACTIONSOURCE = \
+  Actions/WorldAction/AddEmptyBoundaryAction.cpp \
+  Actions/WorldAction/BoundInBoxAction.cpp \
+  Actions/WorldAction/CenterInBoxAction.cpp \
+  Actions/WorldAction/CenterOnEdgeAction.cpp \
+  Actions/WorldAction/ChangeBoxAction.cpp \
+  Actions/WorldAction/RemoveSphereOfAtomsAction.cpp \
+  Actions/WorldAction/RepeatBoxAction.cpp \
+  Actions/WorldAction/ScaleBoxAction.cpp \
+  Actions/WorldAction/SetDefaultNameAction.cpp \
+  Actions/WorldAction/SetGaussianBasisAction.cpp               
+WORLDACTIONHEADER = \
+  Actions/WorldAction/AddEmptyBoundaryAction.hpp \
+  Actions/WorldAction/BoundInBoxAction.hpp \
+  Actions/WorldAction/CenterInBoxAction.hpp \
+  Actions/WorldAction/CenterOnEdgeAction.hpp \
+  Actions/WorldAction/ChangeBoxAction.hpp \
+  Actions/WorldAction/RemoveSphereOfAtomsAction.hpp \
+  Actions/WorldAction/RepeatBoxAction.hpp \
+  Actions/WorldAction/ScaleBoxAction.hpp \
+  Actions/WorldAction/SetDefaultNameAction.hpp \
+  Actions/WorldAction/SetGaussianBasisAction.hpp
+
+
+
+PARSERSOURCE = \
+  Parser/ChangeTracker.cpp \
+  Parser/FormatParser.cpp \
+  Parser/TremoloParser.cpp \
+  Parser/XyzParser.cpp
+PARSERHEADER = \
+  Parser/ChangeTracker.hpp \
+  Parser/FormatParser.hpp \
+  Parser/TremoloParser.hpp \
+  Parser/XyzParser.hpp
+
+PATTERNSOURCE = \
+  Patterns/Observer.cpp
+PATTERNHEADER = \
+  Patterns/Cacheable.hpp \
+  Patterns/Observer.hpp \
+  Patterns/Singleton.hpp
+
+# Below is all for the User Interface
+
+VIEWSOURCE = \
+  Views/View.cpp \
+  Views/StringView.cpp \
+  Views/MethodStringView.cpp \
+  Views/StreamStringView.cpp
+VIEWHEADER = \
+  Views/View.hpp \
+  Views/StringView.hpp \
+  Views/MethodStringView.hpp \
+  Views/StreamStringView.hpp
+
+MENUSOURCE = \
+  Menu/Menu.cpp \
+  Menu/TextMenu.cpp \
+  Menu/MenuItem.cpp \
+  Menu/SubMenuItem.cpp \
+  Menu/ActionMenuItem.cpp \
+  Menu/SeperatorItem.cpp \
+  Menu/DisplayMenuItem.cpp
+  
+MENUHEADER = \
+  Menu/Menu.hpp \
+  Menu/TextMenu.hpp \
+  Menu/MenuItem.hpp \
+  Menu/SubMenuItem.hpp \
+  Menu/ActionMenuItem.hpp \
+  Menu/SeperatorItem.hpp \
+  Menu/DisplayMenuItem.hpp
+
+UISOURCE = \
+  ${ACTIONSSOURCE} \
+  ${COMMANDLINEUISOURCE} \
+  ${MENUSOURCE} \
+  ${TEXTUISOURCE} \
+  ${VIEWSOURCE} \
+  UIElements/Dialog.cpp \
+  UIElements/MainWindow.cpp \
+  UIElements/UIFactory.cpp
+  
+UIHEADER = \
+  ${ACTIONSHEADER} \
+  ${COMMANDLINEUIHEADER} \
+  ${MENUHEADER} \
+  ${TEXTUIHEADER} \
+  ${VIEWHEADER} \
+  UIElements/Dialog.hpp \
+  UIElements/MainWindow.hpp \
+  UIElements/UIFactory.hpp
+
+TEXTUISOURCE = \
+  UIElements/TextDialog.cpp \
+  UIElements/TextStatusIndicator.cpp \
+  UIElements/TextUIFactory.cpp \
+  UIElements/TextWindow.cpp
+TEXTUIHEADER = \
+  UIElements/TextDialog.hpp \
+  UIElements/TextStatusIndicator.hpp \
+  UIElements/TextUIFactory.hpp \
+  UIElements/TextWindow.hpp
+
+COMMANDLINEUISOURCE = \
+  UIElements/CommandLineDialog.cpp \
+  UIElements/CommandLineStatusIndicator.cpp \
+  UIElements/CommandLineUIFactory.cpp \
+  UIElements/CommandLineWindow.cpp
+COMMANDLINEUIHEADER = \
+  UIElements/CommandLineDialog.hpp \
+  UIElements/CommandLineStatusIndicator.hpp \
+  UIElements/CommandLineUIFactory.hpp \
+  UIElements/CommandLineWindow.hpp
 
 # all these files are only used for legacy reasons while the transition is in progress
@@ -71,109 +297,112 @@
 
 DESCRIPTORSOURCE = Descriptors/AtomDescriptor.cpp \
-				   Descriptors/AtomIdDescriptor.cpp \
-				   Descriptors/AtomTypeDescriptor.cpp \
-				   Descriptors/MoleculeDescriptor.cpp \
-				   Descriptors/MoleculeIdDescriptor.cpp 
+  Descriptors/AtomIdDescriptor.cpp \
+  Descriptors/AtomTypeDescriptor.cpp \
+  Descriptors/MoleculeDescriptor.cpp \
+  Descriptors/MoleculeIdDescriptor.cpp 
 				   
 				   
 DESCRIPTORHEADER = Descriptors/AtomDescriptor.hpp \
-				   Descriptors/AtomIdDescriptor.hpp \
-				   Descriptors/AtomTypeDescriptor.hpp \
-				   Descriptors/MoleculeDescriptor.hpp \
-				   Descriptors/MoleculeIdDescriptor.hpp
+  Descriptors/AtomIdDescriptor.hpp \
+  Descriptors/AtomTypeDescriptor.hpp \
+  Descriptors/MoleculeDescriptor.hpp \
+  Descriptors/MoleculeIdDescriptor.hpp
 				   
-
-
 EXCEPTIONSOURCE = Exceptions/CustomException.cpp \
-				  Exceptions/LinearDependenceException.cpp \
-				  Exceptions/MathException.cpp \
-				  Exceptions/ZeroVectorException.cpp
+  Exceptions/LinearDependenceException.cpp \
+  Exceptions/MathException.cpp \
+  Exceptions/ZeroVectorException.cpp
 				  
 EXCEPTIONHEADER = Exceptions/CustomException.hpp \
-				  Exceptions/LinearDependenceException.hpp \
-				  Exceptions/MathException.hpp \
-				  Exceptions/ZeroVectorException.hpp
-
-SOURCE = ${ANALYSISSOURCE} \
-		 ${ATOMSOURCE} \
-		 ${PATTERNSOURCE} \
-		 ${UISOURCE} \
-		 ${DESCRIPTORSOURCE} \
-		 ${HELPERSOURCE} \
-		 ${LEGACYSOURCE} \
-		 ${EXCEPTIONSOURCE} \
-		 bond.cpp \
-		 bondgraph.cpp \
-		 boundary.cpp \
-		 config.cpp \
-		 element.cpp \
-		 ellipsoid.cpp \
-		 errorlogger.cpp \
-		 graph.cpp \
-		 helpers.cpp \
-		 info.cpp \
-		 leastsquaremin.cpp \
-		 Line.cpp \
-		 linkedcell.cpp \
-		 lists.cpp \
-		 log.cpp \
-		 logger.cpp \
-		 memoryusageobserver.cpp \
-		 moleculelist.cpp \
-		 molecule.cpp \
-		 molecule_dynamics.cpp \
-		 molecule_fragmentation.cpp \
-		 molecule_geometry.cpp \
-		 molecule_graph.cpp \
-		 molecule_pointcloud.cpp \
-		 parser.cpp \
-		 periodentafel.cpp \
-		 Plane.cpp \
-		 tesselation.cpp \
-		 tesselationhelpers.cpp \
-		 triangleintersectionlist.cpp \
-		 verbose.cpp \
-		 vector_ops.cpp \
-		 World.cpp
+  Exceptions/LinearDependenceException.hpp \
+  Exceptions/MathException.hpp \
+  Exceptions/ZeroVectorException.hpp
+
+SOURCE = \
+  ${ANALYSISSOURCE} \
+  ${ATOMSOURCE} \
+  ${PATTERNSOURCE} \
+  ${PARSERSOURCE} \
+  ${UISOURCE} \
+  ${DESCRIPTORSOURCE} \
+  ${HELPERSOURCE} \
+  ${LEGACYSOURCE} \
+  ${EXCEPTIONSOURCE} \
+  bond.cpp \
+  bondgraph.cpp \
+  boundary.cpp \
+  CommandLineParser.cpp \
+  config.cpp \
+  element.cpp \
+  ellipsoid.cpp \
+  errorlogger.cpp \
+  graph.cpp \
+  helpers.cpp \
+  info.cpp \
+  leastsquaremin.cpp \
+  Line.cpp \
+  linkedcell.cpp \
+  lists.cpp \
+  log.cpp \
+  logger.cpp \
+  memoryusageobserver.cpp \
+  moleculelist.cpp \
+  molecule.cpp \
+  molecule_dynamics.cpp \
+  molecule_fragmentation.cpp \
+  molecule_geometry.cpp \
+  molecule_graph.cpp \
+  molecule_pointcloud.cpp \
+  parser.cpp \
+  periodentafel.cpp \
+  Plane.cpp \
+  tesselation.cpp \
+  tesselationhelpers.cpp \
+  triangleintersectionlist.cpp \
+  verbose.cpp \
+  vector_ops.cpp \
+  World.cpp
 
 HEADER = \
-	  ${ANALYSISHEADER} \
-	  ${ATOMHEADER} \
-	  ${PATTERNHEADER} \
-	  ${UIHEADER} \
-	  ${DESCRIPTORHEADER} \
-	  ${EXCEPTIONHEADER} \
-	  ${LEGACYHEADER} \
-	  bond.hpp \
-	  bondgraph.hpp \
-	  boundary.hpp \
-	  config.hpp \
-	  defs.hpp \
-	  element.hpp \
-	  ellipsoid.hpp \
-	  errorlogger.hpp \
-	  graph.hpp \
-	  helpers.hpp \
-	  info.hpp \
-	  leastsquaremin.hpp \
-	  Line.hpp \
-	  linkedcell.hpp \
-	  lists.hpp \
-	  log.hpp \
-	  logger.hpp \
-	  memoryallocator.hpp \
-	  memoryusageobserver.hpp \
-	  molecule.hpp \
-	  molecule_template.hpp \
-	  parser.hpp \
-	  periodentafel.hpp \
-	  Plane.hpp \
-	  stackclass.hpp \
-	  tesselation.hpp \
-	  tesselationhelpers.hpp \
-	  triangleintersectionlist.hpp \
-	  verbose.hpp \
-	  vector_ops.hpp \
-	  World.hpp 
+  ${ANALYSISHEADER} \
+  ${ATOMHEADER} \
+  ${PARSERHEADER} \
+  ${PATTERNHEADER} \
+  ${UIHEADER} \
+  ${DESCRIPTORHEADER} \
+  ${EXCEPTIONHEADER} \
+  ${LEGACYHEADER} \
+  bond.hpp \
+  bondgraph.hpp \
+  boundary.hpp \
+  CommandLineParser.hpp \
+  config.hpp \
+  defs.hpp \
+  element.hpp \
+  ellipsoid.hpp \
+  errorlogger.hpp \
+  graph.hpp \
+  helpers.hpp \
+  info.hpp \
+  leastsquaremin.hpp \
+  Line.hpp \
+  linkedcell.hpp \
+  lists.hpp \
+  log.hpp \
+  logger.hpp \
+  memoryallocator.hpp \
+  memoryusageobserver.hpp \
+  molecule.hpp \
+  molecule_template.hpp \
+  parser.hpp \
+  periodentafel.hpp \
+  Plane.hpp \
+  stackclass.hpp \
+  tesselation.hpp \
+  tesselationhelpers.hpp \
+  triangleintersectionlist.hpp \
+  verbose.hpp \
+  vector_ops.hpp \
+  World.hpp 
 
 BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
@@ -188,11 +417,9 @@
 molecuilder_LDFLAGS = $(BOOST_LDFLAGS)
 molecuilder_SOURCES = builder.cpp
-molecuilder_LDADD = libmolecuilder.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
+molecuilder_LDADD = libmolecuilder.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
 joiner_SOURCES = joiner.cpp datacreator.cpp parser.cpp datacreator.hpp helpers.hpp parser.hpp periodentafel.hpp
 joiner_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
 analyzer_SOURCES = analyzer.cpp datacreator.cpp parser.cpp helpers.hpp periodentafel.hpp parser.hpp datacreator.hpp 
 analyzer_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
-
-#EXTRA_DIST = ${molecuilder_DATA}
 
 FORCE:
